import { Transform } from 'stream';
export var process = function (chunk, line, cache) {
    var data = line.tail + chunk;
    var result = '';
    var tracking = line.scopes;
    var indexOpen = 0;
    var indexClose = 0;
    var isOpen = true;
    var phase = 0;
    var _loop_1 = function (index) {
        var c = data[index];
        var push = c;
        if (c === '<') {
            phase = 1;
            indexOpen = index;
            indexClose = 0;
            isOpen = false;
        }
        else if (c === '>') {
            phase = 0;
            indexClose = index;
            push = data.substring(indexOpen, indexClose + 1);
            var tag = push;
            indexOpen = indexClose = 0;
            isOpen = true;
            if (tag[1] === 'x' || tag[2] === 'x') {
                var isStoreOpen = tag.match(/^<x-cached-store-([^>]*)>/i);
                var isStoreClose = tag.match(/^<\/x-cached-store-([^>]*)>/i);
                var isReStore = tag.match(/^<x-cached-restore-([^>]*)\/>/i);
                var isReStoreOpen = tag.match(/^<x-cached-restore-([^>]*)>/i);
                var isReStoreClose = tag.match(/^<\/x-cached-restore-([^>]*)>/i);
                if (!isStoreOpen && !isStoreClose && !isReStore && !isReStoreOpen && !isReStoreClose) {
                }
                else {
                    if (isReStore) {
                        var str = cache.get(+isReStore[1].trim()) || 'broken-cache';
                        push = String(str);
                    }
                    else if (isReStoreOpen) {
                        push = "";
                    }
                    else if (isReStoreClose) {
                        var str = cache.get(+isReStoreClose[1].trim()) || 'broken-cache';
                        push = String(str);
                    }
                    else if (isStoreOpen) {
                        var key = isStoreOpen[1].trim();
                        line.cache[key] = { buffer: "" };
                        push = "";
                    }
                    else if (isStoreClose) {
                        var key = +isStoreClose[1].trim();
                        cache.set(key, line.cache[key].buffer);
                        delete line.cache[key];
                        push = "";
                    }
                }
            }
        }
        else {
            var nextIndex = (phase === 0
                ? data.indexOf('<', index)
                : data.indexOf('>', index));
            if (nextIndex > index) {
                push = data.substring(index, nextIndex);
                index = nextIndex - 1;
            }
        }
        if (isOpen) {
            result += push;
            Object
                .keys(line.cache)
                .forEach(function (key) {
                line.cache[key].buffer += push;
            });
        }
        out_index_1 = index;
    };
    var out_index_1;
    for (var index = 0; index < data.length; index++) {
        _loop_1(index);
        index = out_index_1;
    }
    if (!isOpen) {
        line.tail = data.substring(indexOpen, data.length);
    }
    line.scopes = tracking;
    return result;
};
var createLine = function () { return ({
    cache: {},
    scopes: [],
    tail: [],
}); };
export var cacheRenderedToString = function (str, cache) { return (str.indexOf('x-cached') > 0
    ? process(str, createLine(), cache)
    : str); };
export var createCacheStream = function (cache) {
    var line = createLine();
    return new Transform({
        transform: function (chunk, _, callback) {
            callback(undefined, Buffer.from(process(chunk.toString('utf-8'), line, cache), 'utf-8'));
        },
        flush: function (cb) {
            cb();
        }
    });
};
