"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_uid_1 = require("react-uid");
var PrerenderedControl_1 = require("./PrerenderedControl");
var Uncached = function (_a) {
    var cacheId = _a.cacheId, children = _a.children;
    return (React.createElement("x-cached-store-" + cacheId, null, children));
};
exports.CachedLocation = function (_a) {
    var cacheKey = _a.cacheKey, noCache = _a.noCache, clientCache = _a.clientCache, _b = _a.ttl, ttl = _b === void 0 ? Infinity : _b, refresh = _a.refresh, children = _a.children;
    return (React.createElement(react_uid_1.UIDFork, null,
        React.createElement(PrerenderedControl_1.PrerenderedControls, null, function (_a) {
            var control = _a.control, isServer = _a.isServer;
            if (!isServer && !clientCache || noCache || !control || !control.cache) {
                return children;
            }
            var cached = control.cache.get(cacheKey);
            if (cached && !refresh) {
                return React.createElement("x-cached-restore-" + control.store(cacheKey, cached));
            }
            else {
                return React.createElement(Uncached, { cacheId: control.assign(cacheKey, ttl) }, children);
            }
        })));
};
